package com.zt.plat.module.qms.resource.device.service;

import java.util.*;

import com.zt.plat.module.qms.resource.device.controller.vo.DeviceApplyDetailPageReqVO;
import com.zt.plat.module.qms.resource.device.controller.vo.DeviceApplyDetailRespVO;
import com.zt.plat.module.qms.resource.device.controller.vo.DeviceApplyDetailSaveReqVO;
import jakarta.validation.*;
import com.zt.plat.module.qms.resource.device.dal.dataobject.DeviceApplyDetailDO;
import com.zt.plat.framework.common.pojo.PageResult;

/**
 * 设备通用流程明细 Service 接口
 *
 * @author 后台管理-1
 */
public interface DeviceApplyDetailService {

    List<DeviceApplyDetailRespVO> selectListWithDeviceInfo(DeviceApplyDetailPageReqVO reqVO);

    List<DeviceApplyDetailDO> selectList(DeviceApplyDetailPageReqVO reqVO);

    List<DeviceApplyDetailDO> selectListByApplyId(Long applyId);

    void insertBatch(List<DeviceApplyDetailDO> list);

    /**
     * 创建设备通用流程明细
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    DeviceApplyDetailRespVO createDeviceApplyDetail(@Valid DeviceApplyDetailSaveReqVO createReqVO);

    /**
     * 更新设备通用流程明细
     *
     * @param updateReqVO 更新信息
     */
    void updateDeviceApplyDetail(@Valid DeviceApplyDetailSaveReqVO updateReqVO);

    /**
     * 删除设备通用流程明细
     *
     * @param id 编号
     */
    void deleteDeviceApplyDetail(Long id);

    /**
    * 批量删除设备通用流程明细
    *
    * @param ids 编号
    */
    void deleteDeviceApplyDetailListByIds(List<Long> ids);

    /**
     * 获得设备通用流程明细
     *
     * @param id 编号
     * @return 设备通用流程明细
     */
    DeviceApplyDetailDO getDeviceApplyDetail(Long id);

    /**
     * 获得设备通用流程明细分页
     *
     * @param pageReqVO 分页查询
     * @return 设备通用流程明细分页
     */
    PageResult<DeviceApplyDetailRespVO> getDeviceApplyDetailPage(DeviceApplyDetailPageReqVO pageReqVO);

}